import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;


public class AIDATA {
	
	private int MAX_ACT = 23;
	private String filePrefix= "AI_CAN_";
	private String fileSuffix= ".TXT";
	private String dataName = "DATA.TXT";
	private String folderName  = "data/aiData/AIDATA33" ;
	
	
	File file;
	PrintWriter pw;
	BufferedReader br;
	
	
	public int score;
	public int aiData[];
	public int id;
	public int gen;
	public int old_score;
	public int parent1;
	public int parent2;
	public int actN; 
	public AIDATA(){
		id=-1;
		score=0;
		
	}

	public AIDATA(int inId,int inScore){
		id=inId;
		score=inScore;
	}
	
	public void init(){
		//AIDATA
		// id gen score parent1 parent2 actN reaction1 ... reactionN 
	
		//ALL in int
		file = new File(folderName+"/"+filePrefix+id+fileSuffix);
		
		try {
			br = new BufferedReader(new FileReader(file));
			String line = br.readLine();
			StringTokenizer token = new StringTokenizer(line);
			int temp = Integer.parseInt(token.nextToken());
			id = temp;
			temp = Integer.parseInt(token.nextToken());
			gen= temp;
			temp = Integer.parseInt(token.nextToken());
			old_score = temp;

			temp = Integer.parseInt(token.nextToken());
			parent1 = temp;
			temp = Integer.parseInt(token.nextToken());
			parent2 = temp;
			temp = Integer.parseInt(token.nextToken());
			actN=temp;
			aiData = new int[actN];
			for(int i = 0;i<actN;i++){
				temp = Integer.parseInt(token.nextToken());
				aiData[i] = temp;
			}
					
			
			br.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public AIDATA(int inId,int genn,AIDATA par1,AIDATA par2){
		id=inId;
		gen=genn;
		score = 0;
		parent1 = par1.id;
		parent2 = par2.id;
		actN=par1.actN;
		aiData = new int[actN];
		for(int i = 0;i<actN;i++){
			double a = Math.random();
			if(a<0.1){
				aiData[i]=(int) (Math.random()*MAX_ACT);
			}else if( a < 0.55){
				aiData[i]=par1.aiData[i];
			}else{
				aiData[i]=par2.aiData[i];
			}
		}
	}
	public AIDATA(int inId,int act,String d){
		id=inId;
		gen=0;
		score = 0;
		parent1 = 0;
		parent2 = 0;
		actN=act;
		aiData = new int[actN];
		for(int i = 0;i<actN;i++){
			double a = Math.random();
				aiData[i]=(int) (Math.random()*MAX_ACT);
			
		}
	}
	public void export(){
		//AIDATA
				// id gen score parent1 parent2 actN reaction1 ... reactionN 
				//ALL in int
		try {
			
			file = new File(folderName+"/"+filePrefix+id+fileSuffix);
			pw = new PrintWriter(new BufferedWriter (new FileWriter(file)));
			
			pw.print(id +" ");
			pw.print(gen +" ");
			pw.print(score +" ");
			pw.print(parent1 +" ");
			pw.print(parent2 +" ");
			pw.print(actN +" ");
			
			for(int i = 0;i<actN;i++){
				pw.print(aiData[i] +" ");
				
			}
			
			pw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	

	public AIDATA(String initData){
			
			String line = initData;
			StringTokenizer token = new StringTokenizer(line);
			int temp = Integer.parseInt(token.nextToken());
			id = temp;
			temp = Integer.parseInt(token.nextToken());
			gen= temp;
			temp = Integer.parseInt(token.nextToken());
			old_score = temp;

			temp = Integer.parseInt(token.nextToken());
			parent1 = temp;
			temp = Integer.parseInt(token.nextToken());
			parent2 = temp;
			temp = Integer.parseInt(token.nextToken());
			actN=temp;
			aiData = new int[actN];
			for(int i = 0;i<actN;i++){
				temp = Integer.parseInt(token.nextToken());
				aiData[i] = temp;
			}
					
		
	}
	public AIDATA(int xxx,int xxxx,int k){
		
		//AIDATA
		// id gen score parent1 parent2 actN reaction1 ... reactionN 
	
		//ALL in int
		file = new File(folderName+"/"+"AIN"+k+".txt");
		
		try {
			br = new BufferedReader(new FileReader(file));
			String line = br.readLine();
			StringTokenizer token = new StringTokenizer(line);
			int temp = Integer.parseInt(token.nextToken());
			id = temp;
			temp = Integer.parseInt(token.nextToken());
			gen= temp;
			temp = Integer.parseInt(token.nextToken());
			old_score = temp;

			temp = Integer.parseInt(token.nextToken());
			parent1 = temp;
			temp = Integer.parseInt(token.nextToken());
			parent2 = temp;
			temp = Integer.parseInt(token.nextToken());
			actN=temp;
			aiData = new int[actN];
			for(int i = 0;i<actN;i++){
				temp = Integer.parseInt(token.nextToken());
				aiData[i] = temp;
			}
					
			
			br.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public void exportN(int xxx){
		//AIDATA
				// id gen score parent1 parent2 actN reaction1 ... reactionN 
				//ALL in int
		try {
			
			file = new File(folderName+"/"+"AIN"+xxx+".txt");
			pw = new PrintWriter(new BufferedWriter (new FileWriter(file)));
			
			pw.print(id +" ");
			pw.print(gen +" ");
			pw.print(score +" ");
			pw.print(parent1 +" ");
			pw.print(parent2 +" ");
			pw.print(actN +" ");
			
			for(int i = 0;i<actN;i++){
				pw.print(aiData[i] +" ");
				
			}
			
			pw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}
	
}
