package rule;

import rl.simplerl.RuleWrapper;

/**
 * A singleton wrapper for special rules (combinations). Only one rule at a time
 * can be the active combo. Active combos are inserted manually into the script
 * and their weight is higher than any other. This assures that combinations
 * will only be disrupted by rules with lower priority.
 * 
 * @author Kevin Majchrzak
 * 
 */
public class ActiveComboRuleWrapper {

	public RuleWrapper rule;
	private static ActiveComboRuleWrapper singleton;

	public static ActiveComboRuleWrapper getSingleton() {
		if (singleton != null) {
			return singleton;
		} else {
			return (singleton = new ActiveComboRuleWrapper());
		}
	}

	private ActiveComboRuleWrapper() {
		rule = null;
	}

}
