package rule;

import enumerate.Action;
import fighting.Attack;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class MegaFireballCounter extends Rule {

	public MegaFireballCounter(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {

		boolean enemyMegaFireballInAir = false;

		for (Attack a : gameState.getFrameData().getAttack()) {
			if (a.isPlayerNumber() != gameState.getPlayerNumber()) {
				if (a.getHitDamage() > 100) {
					enemyMegaFireballInAir = true;
					break;
				}
			}
		}

		boolean enemyMegaFireballAction = gameState.getEnemyCharacterData()
				.getAction() == Action.STAND_D_DF_FC;

		return enemyMegaFireballAction || enemyMegaFireballInAir;
	}

	@Override
	public void execute() {
		gameState.getCommandCenter().commandCall("2 1 4 _ B");
	}

	@Override
	public int getPriority() {
		return -10;
	}

}
