package rule;

import enumerate.State;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class MegaFireballEnemyDownHighPrio extends Rule {

	public MegaFireballEnemyDownHighPrio(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {

		int delay = 15;
		int nowRemainingFrame = gameState.getEnemyCharacterData()
				.getRemainingFrame() - delay;
		boolean downOrRising = gameState.getEnemyMotionData().getMotionName()
				.equals("DOWN")
				|| gameState.getEnemyMotionData().getMotionName()
						.equals("RISE");

		return (gameState.getCommandCenter().getDistanceX() < 400)
				&& (gameState.getMyCharacterData().getEnergy() >= 300)
				&& downOrRising && (nowRemainingFrame <= 10)
				&& (gameState.getMyCharacterData().getState() != State.AIR)
				&& (ActiveComboRuleWrapper.getSingleton().rule == null);
	}

	@Override
	public void execute() {
		gameState.getCommandCenter().commandCall("STAND_D_DF_FC");
	}

	@Override
	public int getPriority() {
		return -5;
	}

}
