package rule;

import enumerate.State;

/**
 * 
 * @author Kevin Majchrzak
 * 
 */
public class UppercutAirCounterHighPrio extends Rule {

	public UppercutAirCounterHighPrio(GameStateInterface gameState) {
		super(gameState);
	}

	@Override
	public boolean satisfied() {
		return (gameState.getCommandCenter().getDistanceX() < 250)
				&& (gameState.getEnemyCharacterData().getY() < 270)
				&& (gameState.getMyCharacterData().getState() != State.AIR)
				&& (gameState.getMyCharacterData().getState() != State.DOWN);
	}

	@Override
	public void execute() {
		gameState.getCommandCenter().commandCall("STAND_F_D_DFA");
	}

	@Override
	public int getPriority() {
		return -3;
	}
}
